/* M:/72_INP/26__Records.jsh
Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó

Příkazy a úryvky zadávané ve výpisech v kapitole:
26  Záznamové třídy – třídy typu record
/*************************************************************************/


/*
** Výpis 26.0:	Inicializace
********************************************************************/
/set start Start_26.jsh
/reset
/env
/methods
/********************************************************************


/*
** Výpis 26.1:	Definice záznamu o trojúhelníku definovaném podle věty SSS
** 				(Side-Side-Side) a přehled jeho metod
********************************************************************/
record TriangleSSS(double a, double b, double c) {}
new TriangleSSS(1, 2, 3);
printFCM(TriangleSSS.class);
/********************************************************************


/*
** Výpis 26.2:	Definice interfejsu pro obrazce znající svoji plochu
** 				a záznamu implementujícího tento interfejs pro
 * 				trojúhelníky definované podle věty SSS
********************************************************************/
interface IArea
{
    double area();
}
record TriangleSSSa(double a, double b, double c)
implements IArea
{
    public double area()
    {
        double s = (a + b + c) / 2;
        return Math.sqrt(s * (s - a) * (s - b) * (s - c));
    }
}
IArea ia = new TriangleSSSa(3, 4, 5);
print("Plocha trojúhelníka " + ia + " je " + ia.area());
/********************************************************************


/*
** Výpis 26.3:	Definice záznamové třídy s explicitní definicí
** 				kanonického konstruktoru
********************************************************************/
record TriangleSSSe(double a, double b, double c)
{
    public TriangleSSSe
    {
        println("Volán kanonický konstruktor:\nthis=" + this
              + "\na=" + a + ", b=" + b + ", c=" + c);
    }
    public TriangleSSSe()
    {
        this(3, 4, 5);
        println("Vytvořen trojúhelník implicitní velikosti");
    }
}
printFCM(TriangleSSSe.class);
var it = new TriangleSSSe(10, 20, 30);
var i0 = new TriangleSSSe();
/********************************************************************


/*
** Výpis 26.4:	Závislost nutnosti inicializace parametrů kanonického
** 				konstruktoru na uvedení parametrů
********************************************************************/
record TriangleSSSe1(double a, double b, double c) {
    public TriangleSSSe1 { this.a = a; }
}
record TriangleSSSe2(double a, double b, double c) {
    public TriangleSSSe2(double a, double b, double c) {
        this.a = a;    this.b = b;    //this.c = c;
    }
}
record TriangleSSSe3(double a, double b, double c) {
    public TriangleSSSe3 { a = a*a; b = b*b; c = c*c; }
}
var t3 = new TriangleSSSe3(3, 4, 5);
/********************************************************************


/*
** Výpis 26.5:	Definice interfejsu ITriangleSSS
********************************************************************/
/* Kód je uložen v souboru:
M:/72_Java/b72_j21ref/c26_records/ITriangleSSS.java
*/
/********************************************************************


/*
** Výpis 26.6:	Definice záznamové třídy RightTriangleSSS obsahující
** 				definice statických atributů a konstruktorů
********************************************************************/
/* Kód je uložen v souboru:
M:/72_Java/b72_j21ref/c26_records/RectangularTriangleSSS.java
*/
/********************************************************************


/*
** Výpis 26.7:	Definice záznamové třídy GeneralTriangleSSS definujícího
** 				obecné trojúhelníky zadané prostřednictvím délek stran
********************************************************************/
/* Kód je uložen v souboru:
M:/72_Java/b72_j21ref/c26_records/GeneralTriangleSSS.java
*/
/********************************************************************


/*
** Výpis 26.8:	 Prověrka záznamových tříd implementujících ITriangleSSS
********************************************************************/
/env -class-path ../_72_IDEA_Java20/out/production/_72_IDEA_Java20
import b72_j21ref.c26_records.*;
ITriangleSSS gt = new GeneralTriangleSSS(5,4,3);
ITriangleSSS rt = new RectangularTriangleSSS(3,4);
ITriangleSSS r2 = new RectangularTriangleSSS(Math.sqrt(2));
System.out.println(
  "\ngt.equals(rt) = " + gt.equals(rt) + ",  gt.hashCode()=" + gt.hashCode()
+ "\nrt.equals(gt) = " + rt.equals(gt) + ",  rt.hashCode()=" + rt.hashCode()
+ "\nrt.equals(r2) = " + rt.equals(r2) + ",  r2.hashCode()=" + r2.hashCode());
new RectangularTriangleSSS(3, 4, 5, 6);
/********************************************************************


/*
** Výpis X.0:	Popis
********************************************************************/
                                                               //SYNC
/* Kód je uložen v souboru:
M:/72_Java/b72_j21ref/c26_records/XXX.java
*/
