package b72_j21ref.c17_inheritance;
/* M:/72_Java/b72_j21ref/c17_inheritance/Daughter17.java
 * Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
 */

import static b72_j21ref.c17_inheritance.Reports17.*;



/*******************************************************************************
 * Instance třídy {@code Daughter17} představují dcery.
 * Třída je součástí skupiny tříd demonstrující vlastnosti dědění.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2023-Summer
 */
public class Daughter17 extends Mother17
{
    static { println("#####  Zavádím třídu Daughter17  #####"); }
    { println("+++++  Inicializuji instanci třídy Daughter17  +++++"); }

    /** Počet doposud vytvořených instancí.*/
    protected static int created = 0;

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy. */
    protected final String ID = "D"  + ++created + '-' + super.ID;


    /***************************************************************************
     * Konstruktor instance dcery.
     * Rodičovským podobjektem je virtuální instance třídy {@link Mother17}.
     */
    public Daughter17()
    {
        this(null);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kteří potřebují něco provést
     * před zavoláním rodičovského konstruktoru.
     *
     * @param s Nepoužitý parametr
     */
    protected Daughter17(String s)
    {
        super(intermezzo("=== Daughter17 volá rodičovský konstruktor"));
        constructorReport(this, Daughter17.class);
    }

    /***************************************************************************
     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Daughter17_" + ID + "(" + super.toString() + ")";
    }

    { println("-----  Konec úvodní fáze inicializace Daughter17  -----"); }
    static { println("-----  Třída Daughter17 zavedena  -----"); }
}
