package b72_j21ref.c18_visibility;
/* M:/72_Java/b72_j21ref/c18_visibility/Granddaughter18.java
 * Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
 */


/*******************************************************************************
 * Instance třídy {@code Granddaughter18} představují vnučky.
 * Třída je součástí skupiny tříd využívajících dědění.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2023-Summer
 */
public class Granddaughter18 extends Daughter18 implements IGranddaughter18
{
//== VARIABLE CLASS ATTRIBUTES =================================================

    /** Počet doposud vytvořených instancí –
     *  tento atribut může být v potomcích zakryt, nicméně zůstane přístupný.*/
    private static int created = 0;



//##############################################################################
//== OTHER NON-PRIVATE CLASS METHODS ===========================================

    /***************************************************************************
     * Vypíše jednoduchý název třídy, v níž je metoda definována,
     * a v závorkách jednoduchý název třídy, jíž byla poslána zpráva.
     *
     * @param cls Class-objekt třídy, jíž byla zaslána zpráva
     */
    protected static void protectedStatic(Class<?> cls)
    {
        System.out.println("Granddaughter18: protectedStatic("
                          + cls.getSimpleName() + ")");
    }



//##############################################################################
//== CONSTANT INSTANCE ATTRIBUTES ==============================================

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy.
     *  Tento atribut může být v potomcích zakryt, nicméně zůstane přístupný.*/
    protected final String ID = "G"  + ++created + '-' + super.ID;



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /***************************************************************************
     * Konstruktor instance vnučky.
     * Rodičovským podobjektem je virtuální instance třídy {@link Daughter18}.
     */
    public Granddaughter18()
    {
//        constructorReport(this, Granddaughter18.class);
    }



//== INSTANCE GETTERS AND SETTERS ==============================================

    /***************************************************************************
     * Virtuální metoda vracející identifikační kód instance {@code this}.
     *
     * @return Identifikační kód ("rodné číslo") instance
     */
    public String getID()
    {
        return ID;
    }



//== OTHER NON-PRIVATE INSTANCE METHODS ========================================

    /***************************************************************************
     * Vypíše jednoduchý název třídy, v níž je metoda definována,
     * a v závorkách podpis instance, jíž byla zaslána zpráva.
     */
    @Override
    protected void protectedInstance()
    {
        System.out.println("Granddaughter18: (" + this + ")");
    }


    /***************************************************************************
     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Granddaughter18" + ID + "(" + super.toString() + ")";
    }

}
